import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.util.List;
import java.util.ArrayList;
import java.io.*;

/**
 * 
 *  <p>
 * @author Michael Kolling, Rf
 * @version 2008-02
 */
public class Animal extends MyActor
{
    private static final int OSTEN = 0;
    private static final int WESTEN = 1;
    private static final int NORDEN = 2;
    private static final int SDEN = 3;

    private int cours;
    private Actor lastFoundObject =null;
    
    public Animal()
    {
        setCours(OSTEN);
    }
    
    /**
     * The animal turns anywhere.
     */
    public void turnAnywhere() {
        switch(Greenfoot.getRandomNumber(4)) {
            case 0 : {
                break;
            }
            case 1 : {
                turnLeft();
                break;
            }
            case 2 : {
                turnLeft();
                turnLeft();
                break;
            }
            case 3 : {
                turnLeft();
                turnLeft();
                turnLeft();
                break;
            }
        }
    }
    
    /**
     * berprfen, ob sich ein Objekt in der gleichen Zelle befindet wie das Tier.
     */
    public boolean foundObject(Class myClass)
    {
        lastFoundObject = getOneObjectAtOffset(0, 0, myClass);
        if (lastFoundObject != null) {
            return true;
        }
        else {
            return false;
        }
    }

    public Actor getFoundObject() {
        return lastFoundObject;
    }

    /**
     * Ein Objekt fressen.
     */
    public void eat(Actor objekt)
    {
        if (objekt != null) {
            getWorld().removeObject(objekt);
        }
    }
    /**
     * Zur Vereinfachung kann diese Methode unmittelbar nach objektGefunden(class) aufgerufen werden.
     */
    public void eatFoundObject() {
        if (lastFoundObject !=null)
            eat(lastFoundObject);
    }

    /**
     * Eine Zelle in der Aktuellen Richtung vorwrts gehen.
     */
    public void go()
    {
        if (! canGo()) {
            return;
        }
        switch (cours) {
        case SDEN :
            setLocation(getX(), getY() + 1);
            break;
        case OSTEN :
            setLocation(getX() + 1, getY());
            break;
        case NORDEN :
            setLocation(getX(), getY() - 1);
            break;
        case WESTEN :
            setLocation(getX() - 1, getY());
            break;
        }
    }

    /**
     * berprfen, ob das Tier vorwrts gehen kann, dann wird true zurckgegeben,
     * sonst false.
     */
    public boolean canGo()
    {
        World myWorld = getWorld();
        int x = getX();
        int y = getY();
        switch (cours) {
        case SDEN :
            y++;
            break;
        case OSTEN :
            x++;
            break;
        case NORDEN :
            y--;
            break;
        case WESTEN :
            x--;
            break;
        }
        if (x >= myWorld.getWidth() || y >= myWorld.getHeight()) {
            return false;
        }
        else if (x < 0 || y < 0) {
            return false;
        }
        
        List barrier = myWorld.getObjectsAt(x, y, Barrier.class);
        if(barrier.isEmpty()) {
            return true;
        }else {
            return false;
        }
    }

    /**
     * Um 90 Grad nach links drehen.
     */
    public void turnLeft()
    {
        switch (cours) {
        case SDEN :
            setCours(OSTEN);
            break;
        case OSTEN :
            setCours(NORDEN);
            break;
        case NORDEN :
            setCours(WESTEN);
            break;
        case WESTEN :
            setCours(SDEN);
            break;
        }
    }

    /**
     * Die Richtung ndern, in die das Tier blickt.
     */
    public void setCours(int cours)
    {
        this.cours = cours;
        switch (cours) {
        case SDEN :
            setRotation(90);
            break;
        case OSTEN :
            setRotation(0);
            break;
        case NORDEN :
            setRotation(270);
            break;
        case WESTEN :
            setRotation(180);
            break;
        default :
            break;
        }
    }

    /**
     *  berschriebene Methode, die beim Laden von einer Datei die Blickrichtung wiederherstellt.
     */
    private void readObject( ObjectInputStream aInputStream) throws IOException, ClassNotFoundException
    {
        aInputStream.defaultReadObject();
        setCours(cours);
    }
}