import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * The lemur eats Ants.<BR>
 * It dies after 200 acts, or when he is older than the number of eaten ants multiplied by 5 plus 10.
 *
 * @author Hannes Riechert
 * @version 2008
 */
public class Anteater extends Animal
{
    protected int numberOfAnts = 0;
    private int ants = 0;
    private int acts = 0;
    private int energie = 20;
    private int highestAge = 0;
    
    public Anteater() {
        turnAnywhere();
    }
    
    /**
     * This method does very much.
     */
    public void act() {
        if(energie < acts || highestAge > 199) {
            die();
        }
        else if(foundObject(Anteater.class) && ants > 1) {
            accrete();
            turnAnywhere();
            ants = 0;
        }
        else if(foundObject(Ant.class)) {
            eatFoundObject();
            numberOfAnts++;
            ants++;
        }
        else if(canGo()) {
            go();
        }
        else {
            turnAnywhere();
        }
        
        energie = 15 + 5 * numberOfAnts;
        highestAge++;
        acts++;
    }
    
    /**
     * The Lemur accretes itself.
     */
    public void accrete() {
Anteater l = new Anteater();
        getWorld().addObject(l, getX(), getY());
    }
    
    /**
     * The Anteater dies.
     */
    public void die() {
Anteatersdeath ld = new Anteatersdeath();
        getWorld().addObject(ld, getX(), getY());
        getWorld().removeObject(this);
    }
    
    /**
     * Returns the number of ants.
     */
    public int getNumberOfAnts() {
        return numberOfAnts;
    }
}