import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Hindernis
 * 
 * @author HR
 * @version 2008
 */
public class Barrier extends MyActor
{
    private static final int OSTEN = 0;
    private static final int WESTEN = 1;
    private static final int NORDEN = 2;
    private static final int SDEN = 3;

    private int cours;
    
    public int age = 0;
    
    public Barrier() {
        turnAnywhere();
    }
    
    /**
     * Der Stein bewegt sich alle 200 acts.
     */
    public void act() {
        if(age > 199) {
            if(canGo()) {
                go();
                turnAnywhere();
                age = 0;
            }
            else {
                turnAnywhere();
                if(canGo()) {
                    go();
                    turnAnywhere();
                    age = 0;
                }
            }
        }
        age++;
    }
    
    /**
     * It turns the Object anywhere.
     */
    public void turnAnywhere() {
        switch(Greenfoot.getRandomNumber(4)) {
            case 0 : {
                break;
            }
            case 1 : {
                turnLeft();
                break;
            }
            case 2 : {
                turnLeft();
                turnLeft();
                break;
            }
            case 3 : {
                turnLeft();
                turnLeft();
                turnLeft();
                break;
            }
        }
    }
    
    /**
     * Eine Zelle in der Aktuellen Richtung vorwrts gehen.
     */
    public void go()
    {
        if (! canGo()) {
            return;
        }
        switch (cours) {
        case SDEN :
            setLocation(getX(), getY() + 1);
            break;
        case OSTEN :
            setLocation(getX() + 1, getY());
            break;
        case NORDEN :
            setLocation(getX(), getY() - 1);
            break;
        case WESTEN :
            setLocation(getX() - 1, getY());
            break;
        }
    }

    /**
     * berprfen, ob das Hindernis vorwrts gehen kann, dann wird true zurckgegeben,
     * sonst false.
     */
    public boolean canGo()
    {
        World myWorld = getWorld();
        int x = getX();
        int y = getY();
        switch (cours) {
        case SDEN :
            y++;
            break;
        case OSTEN :
            x++;
            break;
        case NORDEN :
            y--;
            break;
        case WESTEN :
            x--;
            break;
        }
        if (x >= myWorld.getWidth() || y >= myWorld.getHeight()) {
            return false;
        }
        else if (x < 0 || y < 0) {
            return false;
        }
        
        return true;
    }
    
    /**
     * Um 90 Grad nach links drehen.
     */
    public void turnLeft()
    {
        switch (cours) {
        case SDEN :
            setCours(OSTEN);
            break;
        case OSTEN :
            setCours(NORDEN);
            break;
        case NORDEN :
            setCours(WESTEN);
            break;
        case WESTEN :
            setCours(SDEN);
            break;
        }
    }
    
    /**
     * Die Richtung ndern, in die das Tier blickt.
     */
    public void setCours(int cours)
    {
        this.cours = cours;
        switch (cours) {
        case SDEN :
            setRotation(90);
            break;
        case OSTEN :
            setRotation(0);
            break;
        case NORDEN :
            setRotation(270);
            break;
        case WESTEN :
            setRotation(180);
            break;
        default :
            break;
        }
    }
}
