import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * The diagramarea shows the population in the world on a graph.
 * 
 * @author Hannes Riechert
 * @version 2008-10-15
 */
public class Diagramarea extends MyActor
{
    private int Anteaters = 0;
    private int ants = 0;
    private int leafs = 0;
    private int acts = 0;
    private int oldActs = 0;
    private int oldYAnteaters = 570;
    private int oldYAnts = 570;
    private int oldYLeafs = 570;
    
    public void setLocation(int x, int y) {
        return;
    }
    
    /**
     * This method gets the number of Anteaters, ants and leafs in the world<BR>
     * and draw with the method drawOn() a graph.
     */
    public void act() 
    {
        Anteaters = getWorld().getObjects(Anteater.class).size();
        drawOn(1, acts, Anteaters, Color.RED);
        
        ants = getWorld().getObjects(Ant.class).size();
        drawOn(2, acts, ants, Color.BLACK);
        
        leafs = getWorld().getObjects(Leaf.class).size();
        drawOn(3, acts, leafs, Color.GREEN);
        
        acts++;
        
        if (acts > 570) {
            acts = 0;
            getImage().clear();
            setImage("diagramarea.png");
            oldYAnts = 570;
            oldYAnteaters = 570;
            oldYLeafs = 570;
        }
    }
    
    /**
     * Draws the line of the defined animal/plant on.<BR>
     * It uses the old x/y and the new x/y.
     */
    public void drawOn(int who, int x, int y, Color farbe) {
        switch(who) {
            case 1 : {
                if(oldActs == 570) oldActs = 0;
                else {
                getImage().setColor(farbe);
                getImage().drawLine(oldActs, 539 - oldYAnteaters, x, 539 - y);
                getImage().drawLine(oldActs - 1, 538 - oldYAnteaters, x - 1, 538 - y);
                oldYAnteaters = y;
            }
                break;
            }
            case 2 : {
                getImage().setColor(farbe);
                getImage().drawLine(oldActs, 539 - oldYAnts, x, 539 - y);
                getImage().drawLine(oldActs - 1, 538 - oldYAnts, x - 1, 538 - y);
                oldYAnts = y;
                break;
            }
            case 3 : {
                getImage().setColor(farbe);
                getImage().drawLine(oldActs, 539 - oldYLeafs, x, 539 - y);
                getImage().drawLine(oldActs - 1, 538 - oldYLeafs - 1, x - 1, 538 - y);
                oldYLeafs = y;
                break;
            }
        }
        oldActs = acts;
    }
}
