import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.io.*;
/**
 * Abstract underklass from Actor, wich allows a back up of Objects with the interface Serializable.
 *
 * @author Hannes Riechert
 * @version 2008-10-21
 * @see Welt
 */
public abstract class MyActor extends Actor implements Serializable
{
    private static final long serialVersionUID = 4944177799740001L;
    private int xPos, yPos;
    
    /**
     * Overwritten method, wich saves the position of the Obejct before a back up.
     */
    private void writeObject( ObjectOutputStream aOutputStream) throws IOException {
        try {
            xPos=getX();
            yPos=getY();
        } catch (Exception e) {}
        //the default serialization for all non-transient, non-static fields
        aOutputStream.defaultWriteObject();
    }
    
    /**
     * To the rebuild of the x-koordinate.
     * @see Welt.ladeObjekte
     */
    public int getXPos() {
        return xPos;
    }
    /**
     * To the rebuild of the y-koordinate.
     * @see Welt.ladeObjekte
     */
    public int getYPos() {
        return yPos;
    }
}
