import greenfoot.*;  // imports Actor, World, Greenfoot, GreenfootImage
import java.util.*;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.*;

/**
 * Contains some usefull methods.
 * 
 * @author Hannes Riechert
 * @version 2008-10-21
 */
public abstract class MyWorld extends World
{
    /**
     *  The hand-off of the original construktor from World.
     */
    public MyWorld(int width,int height, int size) {
        super(width,height,size);
    }
    
    /**
     * The last condition of the file *.gfobjekte is charging. I
     */
    public void safeObjects() {
        JFileChooser chooser=new JFileChooser("./");
        chooser.addChoosableFileFilter(new GreenfootFileFilter());
        chooser.showSaveDialog(null);
        File file=chooser.getSelectedFile();
        if (file !=null)
            safeObject(getNameNoExtension(file));
    }
    
    /**
     * Safes the condition with a free choosen filename.
     * @param filename without filenameextention. I
     */
   private void safeObject(String filename) {

        List objects = getObjects(MyActor.class);
        // Write to disk with FileOutputStream
        try {
            FileOutputStream f_out = new FileOutputStream(filename+".gfobjekte");
            // Write object with ObjectOutputStream
            ObjectOutputStream obj_out = new ObjectOutputStream (f_out);
            // Write object out to disk
            obj_out.writeObject ( objects );
        } catch (IOException e) {
            throw new Error(e);
        };
    }
    
    /**
     * The last condition of the file *.gfobjekte is charging. II
     */
    public void chargeObjects() {
        JFileChooser chooser=new JFileChooser("./");
        chooser.addChoosableFileFilter(new GreenfootFileFilter());
        chooser.showOpenDialog(null);
        File file=chooser.getSelectedFile();
        if (file !=null) chargeObject(getNameNoExtension(file));
    }
    
    /**
    * Safes the condition with a free choosen filename.
     * @param filename without filenameextention. II
    */

   private void chargeObject(String filename) {
        // Read from disk using FileInputStream
        try {
            FileInputStream f_in = new
            FileInputStream(filename+".gfobjekte");

            // Read object using ObjectInputStream
            ObjectInputStream obj_in =
                new ObjectInputStream (f_in);

            // Read an object
            Object obj = obj_in.readObject();

            if (obj instanceof List)
            {
                for (MyActor a:(List <MyActor>) obj) {
                    addObject(a,a.getXPos(),a.getYPos());
                }
            }
        } catch (Exception e) {
            throw new Error(e);
        }
    }
    
    /**
     *  Helpingclass for javax.swing.FileChooser.
     */
    class GreenfootFileFilter extends javax.swing.filechooser.FileFilter {
        public boolean accept(java.io.File f) {
            if (f.isDirectory()) {
                return true;
            }

            String extension = getExtension(f);
            if (extension != null) {
                if (extension.equals("gfobjekte")) {
                    return true;
                } else {
                    return false;
                }
            }
            return false;

        }
        public String getDescription() {
            return "Greenfoot Objekte";
        }

    }
    
    /**
     * Helpingmethod for GreenfootFileFilter
     */
    private  String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
    
    /**
     * Helpingmethod for safeObjects
     */
    private  String getNameNoExtension(File f) {
        String s = f.getName();
        String name = s;
        int i = s.lastIndexOf('.');

        if (i > 0) {
            name = s.substring(0,i);
        }
        return name;
    }
}